10 '**********************************'
11 '*                                *'
12 '*    Aufbau des Rautenmusters    *'
13 '*          des RAHMENS           *'
14 '*            der UHR             *'
15 '*        und der ZIFFERN         *'
16 '*                                *'
17 '**********************************'
18 '
100 '
101 '**********************************'
102 '*                                *'
103 '*    Aufbau des Rautenmusters    *'
104 '*                                *'
105 '**********************************'
106 '
110 KEY OFF
120 SCREEN 9
130 COLOR 15,0
140 CLS
150 PI      = 3.141593  'Die Zahl PI
160 '
161 '**********************************************
162 '*                                            *
163 '*  Funktion zur Umrechnung der Zeit in den   *
164 '*     entsprechenden Winkel [Bogenma]       *
165 '*                                            *
166 '**********************************************
167 '
170 DEF FNANG(ZEIT) = PI / 2 - PI * ZEIT / 30 - 2 * PI * (ZEIT>= 5)
200 BLAU=1:WEISS=15:BW=0
210 NB=5:NW=10
220 FOR Y=0 TO 349 STEP 1
221 'FOR Y=0 TO 50 STEP 1 :'nur fr Testzwecke'
230 X=5
240 IF BW=1 GOTO 360
250 FOR RAUTEN=1 TO 42 STEP 1
260 FOR I=1 TO NB STEP 1
270 PSET (X,Y),BLAU
280 X=X+1
290 NEXT I
300 FOR I=1 TO NW STEP 1
310 PSET (X,Y),WEISS
320 X=X+1
330 NEXT I
340 NEXT RAUTEN
350 GOTO 460
360 FOR RAUTEN=1 TO 42 STEP 1
370 FOR I=1 TO NW STEP 1
380 PSET (X,Y),WEISS
390 X=X+1
400 NEXT I
410 FOR I=1 TO NB STEP 1
420 PSET (X,Y),BLAU
430 X=X+1
440 NEXT I
450 NEXT RAUTEN
460 IF NB=15 GOTO 530
470 IF NB=0 GOTO 620
480 IF BW=1 GOTO 510
490 NB=NB+1:NW=NW-1
500 GOTO 640
510 NB=NB-1:NW=NW+1
520 GOTO 640
530 Y=Y+1:X=5
540 FOR RAUTEN=1 TO 42 STEP 1
550 FOR I=1 TO NB STEP 1
560 PSET (X,Y),BLAU
570 X=X+1
580 NEXT I
590 NEXT RAUTEN
600 BW=1
610 GOTO 480
620 BW=0
630 GOTO 480
640 NEXT Y
700 '
701 '*************************************'
702 '*                                   *'
703 '*       Zeichen des Rahmens         *'
704 '*                                   *'
705 '*************************************'
706 '
710 LINE (0,0)-(639,349),5,B
720 LINE (1,1)-(638,348),5,B
730 LINE (2,2)-(637,347),5,B
740 LINE (3,2)-(636,347),5,B
750 LINE (4,2)-(635,347),5,B
800 '
801 '*************************************'
802 '*                                   *'
803 '*    Zeichnen des Uhren 8-Ecks      *'
804 '*                                   *'
805 '*************************************'
806 '
810 PSET (320-85,25),7
820 DRAW "A0;R170;TA45;D125;A0;D125;TA135;U125;A0;L170;TA45;U125;A0;U125;TA315;U125;BM320,175;P4,7"
830 PSET (320-85,25),15
840 DRAW "A0;R170;TA45;D125;A0;D125;TA135;U125;A0;L170;TA45;U125;A0;U125;TA315;U125"
900 '
901 '*************************************'
902 '*                                   *'
903 '*   Zeichnen des inneren Kreises    *'
904 '*                                   *'
905 '*************************************'
906 '
910 CIRCLE (320,175),180,15
920 PAINT (320,175),15,15
1000 '
1001 '*************************************'
1002 '*                                   *'
1003 '*        Zeichnen der Zahlen        *'
1004 '*                                   *'
1005 '*************************************'
1006 '
1010 PSET (303,60),5
1020 DRAW "a0;e9;d20;l3;r6"
1030 PSET (304,60),5
1040 DRAW "a0;e9;d20;l3;r6"
1050 PSET (325,56),5
1060 DRAW "a0;ta-25;u5;a0;r7;ta25;d6;a0;d1;g13;r12"
1070 PSET (326,56),5
1080 DRAW "a0;ta-25;u5;a0;r7;ta25;d6;a0;d1;g13;r12"
1090 CIRCLE (477,167),8,5
1100 PSET (483,170),5
1110 DRAW "a0;ta-30;d16"
1120 CIRCLE (477,167),7,5
1130 PSET (484,170),5
1140 DRAW "a0;ta-30;d16"
1150 CIRCLE (320,296),8,5
1160 PSET (313,294),5
1170 DRAW "a0;ta-30;u16"
1180 CIRCLE (320,296),7,5
1190 PSET (314,294),5
1200 DRAW "a0;ta-30;u16"
1210 PSET (155,168),5
1220 DRAW "a0;ta-25;u5;a0;r7;ta25;d6;a0;d1;g4;l4"
1230 PSET (163,174),5
1240 DRAW "a0;f5;d2;ta-25;d6;a0;l7;ta25;u5"
1250 PSET (156,168),5
1260 DRAW "a0;ta-25;u5;a0;r7;ta25;d6;a0;d1;g4;l4"
1270 PSET (164,174),5
1280 DRAW "a0;f5;d2;ta-25;d6;a0;l7;ta25;u5"
1300 '
1301 '*************************************'
1302 '*                                   *'
1303 '*  Zeichnen der Ziffernmarkierungen *'
1304 '*                                   *'
1305 '*************************************'
1306 '
1310 XMITTE%=320:YMITTE%=175
1320 FOR ZIFFER% = 1 TO 12
1330     '
1340     '***** Koordinaten der Kreismittelpunkte berechnen
1350     '***** Umwandlung Polarkoordinaten --> kartesische
1360     '      Koordinaten
1370     XZIFFER% = XMITTE% + 155 * COS(FNANG(ZIFFER% * 5))
1380     YZIFFER% = YMITTE% - 115 * SIN(FNANG(ZIFFER% * 5))
1390     '
1400     IF (ZIFFER% = 3) OR (ZIFFER% =  6) THEN 1480
1410     IF (ZIFFER% = 9) OR (ZIFFER% = 12) THEN 1480
1420     '
1430     '***** Ziffernmarkierung zeichnen
1440     RAD% = 3
1450     CIRCLE (XZIFFER%, YZIFFER%), RAD%,5
1460     'PAINT (XZIFFER%, YZIFFER%),5,5
1470     '
1480 NEXT ZIFFER%
8000 '
8001 '*************************************'
8002 '*                                   *'
8003 '*      Abspeichern des Bildes       *'
8004 '*                                   *'
8005 '*************************************'
8006 '
8010 DEF SEG =&HA000
8020 OUT &H3CE,4
8030 OUT &H3CF,0
8040 BSAVE "BILD.IM1",0,28000!
8050 OUT &H3CE,4
8060 OUT &H3CF,1
8070 BSAVE "BILD.IM2",0,28000!
8080 OUT &H3CE,4
8090 OUT &H3CF,2
8100 BSAVE "BILD.IM3",0,28000!
8110 OUT &H3CE,4
8120 OUT &H3CF,3
8130 BSAVE "BILD.IM4",0,28000!
